diff --git a/web/pgadmin/static/js/selection/range_boundary_navigator.js b/web/pgadmin/static/js/selection/range_boundary_navigator.js
index 582e31e9..c4710027 100644
--- a/web/pgadmin/static/js/selection/range_boundary_navigator.js
+++ b/web/pgadmin/static/js/selection/range_boundary_navigator.js
@@ -158,6 +158,8 @@ define(['sources/selection/range_selection_helper', 'json-bignumber'],
             val = quote_char + JSONBigNumber.stringify(val) + quote_char;
           } else if (val && cell_type != 'number' && cell_type != 'boolean') {
             val = quote_char + escape(val.toString()) + quote_char;
+          } else if (cell_type == 'string' && _.isNull(val)){
+            val = null;
           } else if (_.isNull(val) || _.isUndefined(val)) {
             val = '';
           }
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index 85d5956e..b87051bf 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -4172,6 +4172,7 @@ define('tools.querytool', [
         if(pgAdmin.SqlEditor.copiedInOtherSessionWithHeaders) {
           copied_rows = copied_rows.slice(1);
         }
+        var row_index = 0;
         copied_rows = copied_rows.reduce((partial, values) => {
           // split each row with field separator character
           let row = {};
@@ -4182,13 +4183,27 @@ define('tools.querytool', [
             if(v === '') {
               if(self.columns[col].has_default_val) {
                 v = undefined;
+              } else if (self.copied_rows[row_index][self.columns[col].display_name] === null) {
+                v = null;
+              } else {
+                v = '';
+              }
+            }
+
+            if(self.columns[col].cell === 'boolean') {
+              if(v == 'true') {
+                v = true;
+              } else if(v == 'false') {
+                v = false;
               } else {
                 v = null;
               }
             }
+
             row[self.columns[col].name] = v;
           }
           partial.push(row);
+          row_index ++;
           return partial;
         }, []);
 
